Index: imaps-frontend/src/scripts/main/MapDisplay.js
===================================================================
--- imaps-frontend/src/scripts/main/MapDisplay.js	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-frontend/src/scripts/main/MapDisplay.js	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -3,121 +3,216 @@
 import HttpService from "../net/HttpService.js";
 import {zoomStage} from "../util/zoomStage.js";
+import {addEventHandling} from "../util/addEventHandling.js";
+import triggerNavigate from "../util/triggerNavigate.js";
+import config from "../net/netconfig.js";
+
 export class MapDisplay {
-  constructor(containerId) {
-    this.container = document.getElementById(containerId);
-    this.containerId = containerId;
-    this.stage = new Konva.Stage({
-      container: containerId,
-      width: window.innerWidth,
-      height: window.innerHeight,
-      draggable: true,
-    });
-
-    this.shapes = [];
-    this.loaded = false;
-    this.mainLayer = new Konva.Layer();
-    this.routeLayer = new Konva.Layer();
-    this.textLayer = new Konva.Layer();
-    this.stage.add(this.mainLayer);
-    this.stage.add(this.routeLayer);
-    this.stage.add(this.textLayer);
-    this.route = new Konva.Line();
-
-    this.stage.on("resize", () => {
-      this.stage.width = window.innerWidth;
-      this.stage.height = window.innerHeight;
-    });
-
-    this.stage.on("wheel",(e) => {
-        zoomStage(e,this.stage);
-    })
-
-   
-  }
-
-  deserializeMap(data) {
-    data.forEach((child) => {
-        const shape = JSON.parse(child);
-        if (shape.className !== "InfoPin") {
-            const renderedShape = Factory.createRenderedShape(
-                shape.className,
-                shape.attrs
-            );
-            this.shapes.push(renderedShape);
-      }
-    });
-  }
-
-  displayRoomNames(){
-    console.log("VLEZE")
-    this.shapes.forEach(shape => {
-      shape.displayName(this.textLayer);
-    })
-
-    this.textLayer.children.forEach(child => console.log(child,"DECAAA"));
-  }
-
-  async loadMap() {
-    const httpService = new HttpService();
-    const mapData = await httpService.get("/public/mapData");
-    console.log("DESERIALIZED --->",mapData);
-    this.deserializeMap(mapData);
-    this.shapes.forEach((shape) => {
-      this.mainLayer.add(shape);
-    });
-    this.displayRoomNames();
-  }
-
-  drawRoute(path) {
-    this.routeLayer.removeChildren();
-    console.log("====PATH====");
-    path.forEach((point) => console.log(point.x, point.y));
-
-    const pointsArray = path.flatMap((point) => [point.x, point.y]);
-
-    console.log(pointsArray, "POINTS");
-
-    let buff = [];
-    let count = 0;
-    let index = 0;
-
-    const drawNextSegment = () => {
-        if (index >= pointsArray.length) return;
-
-        buff.push(pointsArray[index]);
-        count++;
-
-        if (count % 4 === 0) {
-            const line = new Konva.Arrow({
-                points: buff,
-                stroke: "#e91332",
-                strokeWidth: 2.5,
-                dash: [5, 4],
-                lineCap: 'round',
-                lineJoin: 'round',
-                pointerLength: 7,
-                pointerWidth: 7,
-                fill:'red',
-            });
-
-            this.routeLayer.add(line);
-            this.routeLayer.draw(); 
-
-            console.log(buff, "BUFFER");
-            buff = []; 
-            index -= 2; 
+    constructor(containerId, floorNum) {
+        this.container = document.getElementById(containerId);
+        this.containerId = containerId;
+        this.stage = new Konva.Stage({
+            container: containerId,
+            width: window.innerWidth,
+            height: window.innerHeight,
+            draggable: true,
+        });
+
+        this.shapes = [];
+        this.roomTypes = [];
+        this.loaded = false;
+        this.mainLayer = new Konva.Layer();
+        this.routeLayer = new Konva.Layer();
+        this.textLayer = new Konva.Layer();
+        this.stage.add(this.mainLayer);
+        this.stage.add(this.routeLayer);
+        this.stage.add(this.textLayer);
+
+        this.floorNum = floorNum;
+
+        this.navArrow = new Konva.Arrow({
+            stroke: "#bb0000",
+            strokeWidth: 3,
+            dash: [12, 7],
+            lineCap: "round",
+            tension: 10,
+            pointerLength: 2,
+            pointerWidth: 3,
+        });
+
+        this.navArrow.cache();
+
+        this.stage.on("resize", () => {
+            this.stage.width = window.innerWidth;
+            this.stage.height = window.innerHeight;
+        });
+
+        this.stage.on("wheel", (e) => {
+            zoomStage(e, this.stage);
+        });
+    }
+
+    clearMap() {
+        this.mainLayer.removeChildren();
+        this.shapes.forEach(shape => shape.clearText())
+        this.shapes = [];
+    }
+
+    deserializeMap(data) {
+        this.clearMap();
+
+        let dsrData = JSON.parse(data);
+        dsrData.forEach((shape) => {
+            if (shape.className !== "InfoPin") {
+                const renderedShape = Factory.createRenderedShape(shape.className, shape.attrs);
+                addEventHandling(renderedShape, this, "click");
+                this.shapes.push(renderedShape);
+            }
+        });
+    }
+
+    displayRoomNames() {
+        this.shapes.forEach((shape) => {
+            shape.displayName(this.textLayer);
+        });
+
+    }
+
+
+
+    loadMapN(floorData) {
+        if (floorData == null || floorData === "") return;
+
+        this.deserializeMap(floorData);
+        this.shapes.forEach((shape) => {
+            this.mainLayer.add(shape);
+        });
+        this.displayRoomNames();
+        this.initializeRoomTypes();
+
+    }
+
+    clearRoute() {
+        this.routeLayer.removeChildren();
+    }
+
+
+    drawRouteNEW(nodes, offset = 0) {
+
+        this.clearRoute();
+        console.log("====PATH====");
+        nodes.forEach((node) => console.log("NODE", node));
+
+        let idx = offset;
+        let buff = [nodes[idx].coordinates.x, nodes[idx].coordinates.y];
+
+
+        ++idx;
+
+        console.log("INIT BUFFER", buff);
+        console.log("INIT IDX", idx);
+
+        const drawNextSegment = () => {
+
+            if (idx >= nodes.length){
+                return;
+            }
+
+            const currentNode = nodes[idx - 1];
+            const nextNode = nodes[idx];
+
+            if (nextNode.floorNumber !== currentNode.floorNumber) {
+                triggerNavigate(nodes, idx, nextNode.floorNumber, nextNode);
+                return;
+            }
+
+            const startX = currentNode.coordinates.x;
+            const startY = currentNode.coordinates.y;
+            const endX = nextNode.coordinates.x;
+            const endY = nextNode.coordinates.y;
+
+            const numSegments = 12;
+
+            const deltaX = (endX - startX) / numSegments;
+            const deltaY = (endY - startY) / numSegments;
+
+            const drawSegment = (i) => {
+                const segmentX = startX + deltaX * i;
+                const segmentY = startY + deltaY * i;
+
+                buff.push(segmentX, segmentY);
+
+                let line = this.navArrow.clone({ points: [...buff] });
+                this.routeLayer.add(line);
+                this.routeLayer.draw();
+
+                buff = [segmentX, segmentY];
+            };
+
+            let segmentIdx = 1;
+            const interval = setInterval(() => {
+                drawSegment(segmentIdx);
+                segmentIdx++;
+
+                if (segmentIdx > numSegments) {
+                    clearInterval(interval);
+                    idx++;
+                    setTimeout(drawNextSegment, 150);
+                }
+            }, 50);
+        };
+
+        drawNextSegment();
+    }
+
+
+
+    initializeRoomTypes() {
+        this.roomTypes = this.shapes
+            .filter((shape) => shape.class === "Room" && shape.info.type !== "")
+            .map((shape) => shape.info.type);
+    }
+
+    getRoomTypes() {
+        return this.roomTypes;
+    }
+
+
+    getShapeByName(name){
+        return this.shapes.find(shape => shape.info.name === name)
+    }
+
+    getShapeByType(type) {
+        return this.shapes.filter((shape) => shape.class === type)
+    }
+
+    toggleSearchRoom() {
+        this.toggleSearch = !this.toggleSearch;
+    }
+
+    //ova e loso ne trebit vaka
+    highlightShape(roomName) {
+        let foundShape = this.shapes.filter((shape) => shape.info.name === roomName)[0];
+        foundShape.highlight();
+    }
+
+    getMainEntrance() {
+        return this.shapes.filter(shape => shape.class === "Entrance").filter(el => el.info.isMainEntrance === true)[0];
+    }
+
+    setFilter(filter) {
+        let rooms = this.getShapeByType("Room")
+        if (filter === "All") {
+            rooms.forEach((shape) => {
+                shape.unHighlight()
+            })
+        } else {
+            rooms.filter((shape) => shape.info.type === filter).forEach((shape) => {
+                shape.highlight()
+            })
+            rooms.filter((shape) => shape.info.type !== filter).forEach((shape) => {
+                shape.unHighlight()
+            })
         }
 
-        index++;
-
-        setTimeout(drawNextSegment, 25); 
-    };
-
-    drawNextSegment(); 
+    }
 }
-
-
-  search() {
-    console.log("VLEZE VO SEARCH");
-  }
-}
Index: imaps-frontend/src/scripts/net/HttpService.js
===================================================================
--- imaps-frontend/src/scripts/net/HttpService.js	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-frontend/src/scripts/net/HttpService.js	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -3,6 +3,5 @@
 
 class HttpService {
-    constructor(URL = config.apiBaseUrl, auth = false) {
-      this.baseURL = URL;
+    constructor(auth = false) {
       this.auth = auth;
     }
@@ -33,5 +32,5 @@
       }
   
-      const response = await fetch(`${this.baseURL}${endpoint}`, options);
+      const response = await fetch(`${endpoint}`, options);
       
       if (!response.ok) {
Index: imaps-frontend/src/scripts/net/netconfig.js
===================================================================
--- imaps-frontend/src/scripts/net/netconfig.js	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-frontend/src/scripts/net/netconfig.js	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -1,14 +1,57 @@
+export const API_BASE_URL = "http://localhost:8080/api";
+export const API_PROTECTED = `${API_BASE_URL}/protected`
+export const API_PUBLIC = `${API_BASE_URL}/public`
+export const API_AUTH = `${API_BASE_URL}/auth`
+
 
 const config = {
-    apiBaseUrl: "http://localhost:8080/api",
+    my_maps: {
+        display: `${API_PROTECTED}/my-maps`,
+        save: `${API_PROTECTED}/my-maps/save`,
+        add: `${API_PROTECTED}/my-maps/create`,
+        load: `${API_PROTECTED}/my-maps/load`,
+        delete: `${API_PROTECTED}/my-maps/delete`,
+        publish: `${API_PROTECTED}/publish/add`,
+        publish_get: `${API_PROTECTED}/publish/get`,
+    },
+    room_types: {
+        display: (auth) => {
+            return auth ? `${API_PROTECTED}/room-types` : `${API_PUBLIC}/room-types`
+        },
+        add: `${API_PROTECTED}/room-types/add`,
 
-    endpoints: {
-        login: "/auth/login",
-        register: "/auth/register",
-        verify: "/auth/verify",
-        render: "/protected/render",
-        publicMapData: "/public/mapData"
+    },
+    floors: {
+        add: `${API_PROTECTED}/floors/add`,
+        load: `${API_PROTECTED}/my-maps/load`,
+        delete: `${API_PROTECTED}/floors/delete`,
+    },
+    view_maps: {
+        display: `${API_PUBLIC}/maps`,
+        load: (auth) => {
+            return auth ? `${API_PROTECTED}/load-map` : `${API_PUBLIC}/load-map`
+        },
+        navigate: `${API_PUBLIC}/navigate`,
+        add_favourite: `${API_PROTECTED}/favourites/add`,
+    },
+    favourites: {
+        display: `${API_PROTECTED}/favourites`,
+        add: `${API_PROTECTED}/favourites/add`,
+        delete: `${API_PROTECTED}/favourites/delete`,
+    },
+    auth:{
+        login: `${API_AUTH}/login`,
+        register: `${API_AUTH}/register`,
+        verify: `${API_AUTH}/verify`
+
+    },
+    admin:{
+        display: `${API_BASE_URL}/admin`,
+        load_pr: `${API_BASE_URL}/admin/load-pr`,
+        approve_pr: `${API_BASE_URL}/admin/pr/approve`,
+        deny_pr: `${API_BASE_URL}/admin/pr/deny`
     }
 };
 
+
 export default config;
Index: imaps-frontend/src/scripts/rendered_shapes/RenderedEntrance.js
===================================================================
--- imaps-frontend/src/scripts/rendered_shapes/RenderedEntrance.js	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-frontend/src/scripts/rendered_shapes/RenderedEntrance.js	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -1,37 +1,44 @@
-import RenderedMapShape from "./RenderedMapShape.js";
+import RenderedMapShape from "../base/RenderedMapShape.js";
+import {_registerNode} from "konva/lib/Global";
+import RenderedRoom from "./RenderedRoom.js";
 
-export default class RenderedEntrance extends RenderedMapShape{
-    constructor(attrs,scaleX,scaleY){
-        super({
-            x: attrs.x,
-            y: attrs.y,
-            width: attrs.width * scaleX,
-            height: attrs.height * scaleY,
-            fill: '#1c3cff',
-            stroke: 'black',
-            strokeWidth: 1,
-            draggable: false,
-            rotation: attrs.rotation,
-            cornerRadius:3,
-            zIndex: 0
-        });
+export default class RenderedEntrance extends RenderedMapShape {
+  constructor(attrs, scaleX, scaleY) {
+    super({
+      x: attrs.x,
+      y: attrs.y,
+      width: attrs.width * scaleX,
+      height: attrs.height * scaleY,
+      fill: "#7fef83",
+      stroke: "black",
+      strokeWidth: 1,
+      draggable: false,
+      rotation: attrs.rotation,
+      cornerRadius: 3,
+      zIndex: 0,
+    });
 
-        this.info.name = attrs.obj_name;
-        this.info.description = attrs.description;
-        
-    
-        this.on("mouseenter",() => {
-        console.log("HOVER ROOM IN", this.x());
-        console.log(this.info.name,"NAME");
-        this.stroke('purple');
-        })
-        this.on("mouseleave", () => {
-            console.log("HOVER ROOM OUT");
-            this.opacity(1);
-            this.stroke('black')
+    this.info.name = attrs.obj_name;
+    this.info.description = attrs.description;
+    this.info.isMainEntrance = attrs.is_main_entrance;
 
-        })
+    this.floorNum = attrs.floor_num
 
-        this.initText()
-    }
+    this.class = "Entrance";
+
+    console.log("ATTRS VIEW:  " + attrs)
+
+    this.on("mouseenter", () => {
+      this.stroke("purple");
+    });
+    this.on("mouseleave", () => {
+      this.opacity(1);
+      this.stroke("black");
+    });
+
+    //this.initText();
+  }
 }
+
+RenderedEntrance.prototype.className = "RenderedEntrance";
+_registerNode(RenderedEntrance);
Index: imaps-frontend/src/scripts/rendered_shapes/RenderedRoom.js
===================================================================
--- imaps-frontend/src/scripts/rendered_shapes/RenderedRoom.js	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-frontend/src/scripts/rendered_shapes/RenderedRoom.js	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -1,41 +1,62 @@
-import RenderedMapShape from "./RenderedMapShape.js";
+import RenderedMapShape from "../base/RenderedMapShape.js";
+import {_registerNode} from "konva/lib/Global";
 
-export default class RenderedRoom extends RenderedMapShape{
-    constructor(attrs,scaleX,scaleY){
-        super({
-            x: attrs.x,
-            y: attrs.y,
-            width: attrs.width * scaleX,
-            height: attrs.height * scaleY,
-            fill: 'white',
-            stroke: 'black',
-            strokeWidth: 1,
-            draggable: false,
-            rotation: attrs.rotation,
-            cornerRadius:3,
-            zIndex: 0
-        });
+export default class RenderedRoom extends RenderedMapShape {
+  constructor(attrs, scaleX, scaleY) {
+    super({
+      x: attrs.x,
+      y: attrs.y,
+      width: attrs.width * scaleX,
+      height: attrs.height * scaleY,
+      fill: "#A2D9FF",
+      stroke: "black",
+      strokeWidth: 1,
+      draggable: false,
+      rotation: attrs.rotation,
+      cornerRadius: 3
+    });
 
-        this.info.name = attrs.obj_name;
-        this.info.description = attrs.description;
+    console.info("FNUM RENDER:",attrs.floor_num)
 
-        this.textOffsetX = -50
-        
-    
-        this.on("mouseenter",() => {
-        console.log("HOVER ROOM IN", this.x());
-        console.log(this.info.name,"NAME");
-        this.opacity(0.7);
-        this.fill("pink");
-        })
-        this.on("mouseleave", () => {
-            console.log("HOVER ROOM OUT");
-            this.opacity(1);
-            this.fill("white");
-        })
+    this.floorNum = attrs.floor_num
 
-        this.initText()
-    }
+    this.info.name = attrs.obj_name;
+    this.info.type = attrs.room_type;
+    this.info.description = attrs.description;
+    this.class = "Room";
+    this.textOffsetX = -50;
 
-   
+    this.eventName = "openRoomInfoPanel"
+
+    this.on("mouseenter", () => {
+      console.log(this.info.name, "NAME");
+      this.fill("#65c3f8");
+    });
+    this.on("mouseleave", () => {
+      this.fill("#A2D9FF");
+    });
+
+
+
+    // searched(){
+    //   this.fill("#b92d39")
+    // }
+    // unsearched(){
+    //   this.fill("#A2D9FF");
+    // }
+
+    // console.log("ATTRS: " + attrs);
+
+    this.initText();
+  }
+  highlight(){
+    this.fill("rgba(29,238,78,0.49)");
+    this.strokeWidth(2)
+  }
+  unHighlight(){
+    this.fill("#A2D9FF");
+    this.strokeWidth(1);
+  }
 }
+RenderedRoom.prototype.className = "RenderedRoom";
+_registerNode(RenderedRoom);
Index: imaps-frontend/src/scripts/rendered_shapes/RenderedStairs.js
===================================================================
--- imaps-frontend/src/scripts/rendered_shapes/RenderedStairs.js	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/scripts/rendered_shapes/RenderedStairs.js	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,43 @@
+import RenderedMapShape from "../base/RenderedMapShape.js";
+import Stairs from "../shapes/Stairs.js";
+import {_registerNode} from "konva/lib/Global";
+import Konva from "konva";
+export default class RenderedStairs extends RenderedMapShape{
+    constructor(attrs,scaleX,scaleY) {
+        super({
+            x: attrs.x,
+            y: attrs.y,
+            width: attrs.width * scaleX,
+            height: attrs.height * scaleY,
+            fill: "rgb(199,190,133)",
+            stroke: "rgb(16,15,15)",
+            strokeWidth: 1,
+            name: "mapObj",
+            rotation: attrs.rotation,
+        });
+
+
+        this.floorNum = attrs.floor_num;
+        this.info.name = attrs.obj_name;
+        //this.initText()
+    }
+
+
+
+
+    _sceneFunc(context, shape) {
+        const { width, height} = this.attrs;
+
+        let steps = 5;
+        let offset = 10;
+        context.beginPath()
+        for(let i = 0; i < steps; i++){
+            context.rect((-offset) * i,(offset * 0.6) * i,width * 0.86,height/2)
+            context.fillStrokeShape(shape);
+        }
+        context.closePath()
+    }
+}
+
+RenderedStairs.prototype.className = "RenderedStairs";
+_registerNode(RenderedStairs);
Index: imaps-frontend/src/scripts/rendered_shapes/RenderedWall.js
===================================================================
--- imaps-frontend/src/scripts/rendered_shapes/RenderedWall.js	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-frontend/src/scripts/rendered_shapes/RenderedWall.js	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -1,3 +1,4 @@
-import RenderedMapShape from "./RenderedMapShape.js";
+import RenderedMapShape from "../base/RenderedMapShape.js";
+import {_registerNode} from "konva/lib/Global";
 
 export default class RenderedWall extends RenderedMapShape{
@@ -8,5 +9,5 @@
             width: attrs.width * scaleX,
             height: attrs.height * scaleY,
-            fill: 'grey',
+            fill: '#4B4B4B',
             stroke: 'black',
             strokeWidth: 1,
@@ -18,2 +19,5 @@
     }
 }
+
+RenderedWall.prototype.className = "RenderedWall";
+_registerNode(RenderedWall);
Index: imaps-frontend/src/scripts/shapes/Entrance.js
===================================================================
--- imaps-frontend/src/scripts/shapes/Entrance.js	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-frontend/src/scripts/shapes/Entrance.js	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -1,58 +1,88 @@
-import Konva from "konva";
-import MapShape from "./MapShape";
-import { _registerNode } from "konva/lib/Global";
-export default class Entrance extends MapShape {
-  constructor(mousePos, blockSize, layer, rotation, snap,id,scaleX = 1, scaleY = 1) {
-    super(
-      {
-        x: mousePos.x,
-        y: mousePos.y,
-        width: blockSize * scaleX,
-        height: blockSize * 2 * scaleY,
-        fill: "#0051ff",
-        stroke: "grey",
-        strokeWidth: 1,
-        opacity: 0.7,
-        name: "mapObj",
-        draggable: true,
-        rotation: rotation,
-        zIndex: 1,
-      },
-      layer,
-      blockSize,
-      snap
-    );
-    this.type = "Entrance";
-    this.modalEventName = "openEntranceModalEvent";
+import {_registerNode} from "konva/lib/Global";
+import MapNode from "../base/MapNode.js";
+import {node} from "prop-types";
 
-    this.id = id;
+export default class Entrance extends MapNode {
 
-    this._info = {
-      name: `Entrance ${id}`,
-      connectedRoom: "",
-      description: "",
-      isMainEntrance: false,
-      selectedPin: "",
-      selectedPins: [],
-    };
+    constructor(attrs, id) {
 
-    this.initText();
-  }
+        if (!attrs.fromLoad) {
+            attrs.height *= 2;
+        }
+        super(
+            {
+                x: attrs.position.x,
+                y: attrs.position.y,
+                width: attrs.width,
+                height: attrs.height,
+                fill: "rgb(126,238,167)",
+                stroke: "#252627",
+                strokeWidth: 1,
+                opacity: 0.9,
+                name: "mapObj",
+                draggable: true,
+                rotation: attrs.rotation,
+                zIndex: 1,
+            },
+            attrs.layer,
+            attrs.blockSize,
+            attrs.snap
+        );
+        this.type = "Entrance";
+        this.eventName = "openEntranceModalEvent";
+        this.floorNum = attrs.floorNum
 
-  loadInfo(attrs) {
-    this.info.name = attrs.obj_name;
-    this.info.connectedRoom = attrs.connected_room;
-    this.info.description = attrs.description;
-    this.info.isMainEntrance = attrs.is_main_entrance;
-    this.info.selectedPins = attrs.connected_pins;
-  }
+        this.id = id;
 
-  saveShapeDetails() {
-    this.setAttr("connected_pins", this.info.selectedPins);
-    this.setAttr("obj_name", this.info.name);
-    this.setAttr("description", this.info.description);
-    this.setAttr("is_main_entrance", this.info.isMainEntrance);
-    this.setAttr("connected_room", this.info.connectedRoom);
-  }
+        this._info = {
+            name: `Entrance${id} [${this.floorNum}F]`,
+            connectedRoom: "",
+            description: "",
+            isMainEntrance: false,
+            selectedPin: "",
+            selectedPins: [],
+        };
+
+        this.initText();
+        this.moveToTop();
+    }
+
+    loadInfo(attrs) {
+        this.info.name = attrs.obj_name;
+        this.info.connectedRoom = attrs.connected_room;
+        this.info.description = attrs.description;
+        this.info.isMainEntrance = attrs.is_main_entrance;
+        this.info.selectedPins = attrs.connected_pins;
+        this.floorNum = attrs.floor_num;
+    }
+
+    saveShapeDetails() {
+        console.info("fnum entrance",this.attrs.floorNum)
+
+        this.setAttr("connected_pins", this.info.selectedPins);
+        this.setAttr("obj_name", this.info.name);
+        this.setAttr("description", this.info.description);
+        this.setAttr("is_main_entrance", this.info.isMainEntrance);
+        this.setAttr("connected_room", this.info.connectedRoom);
+        this.setAttr("floor_num",this.floorNum);
+    }
+
+    connect(node, draw = true) {
+        if(this.floorNum !== node.floorNum) return;
+
+        super.connect(node)
+    }
+
+    setInfo(infoObj) {
+        console.log("SA VIKNA SETINFO")
+        this.info = infoObj;
+        if(this.info.connectedRoom == null || this.info.connectedRoom === "" ){
+            this.strokeWidth(2);
+            this.stroke("#a10114")
+        }else{
+            this.strokeWidth(1)
+            this.stroke("black")
+        }
+    }
 }
 
Index: imaps-frontend/src/scripts/shapes/InfoPin.js
===================================================================
--- imaps-frontend/src/scripts/shapes/InfoPin.js	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-frontend/src/scripts/shapes/InfoPin.js	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -1,32 +1,35 @@
-import Konva from "konva";
-import MapShape from "./MapShape";
-import Factory from "../util/Factory";
+
 import { _registerNode } from "konva/lib/Global";
-export default class InfoPin extends MapShape {
-  constructor(mousePos, blockSize, layer, snappable,id) {
+import MapNode from "../base/MapNode.js";
+import {node} from "prop-types";
+import draw from "../../pages/Draw/Draw.jsx";
+export default class InfoPin extends MapNode {
+  constructor(attrs,id) {
+    attrs.snap = false;
     super(
       {
-        x: mousePos.x,
-        y: mousePos.y,
-        radiusX: blockSize * 0.5,
-        radiusY: blockSize * 0.7,
-        tailHeight: blockSize * 1.2,
-        fill: "#d70113",
+        x: attrs.position.x,
+        y: attrs.position.y,
+        radiusX: attrs.blockSize * 0.5,
+        radiusY: attrs.blockSize * 0.7,
+        tailHeight: attrs.blockSize * 1.2,
+        fill: "#f60000",
         stroke: "#1b1b1b",
-        strokeWidth: 0.2,
+        strokeWidth: 1,
         draggable: true,
         name: "mapObj",
       },
-      layer,
-      blockSize,
-      snappable
+      attrs.layer,
+      attrs.blockSize,
+      attrs.snap
     );
 
     this.id = id;
+    this.eventName = "openPinModalEvent";
+    this.floorNum = attrs.floorNum;
 
-    this.modalEventName = "openPinModalEvent";
     this.type = "InfoPin";
     this._info = {
-      name: `Pin ${id}`,
+      name: `Pin${id} [${this.floorNum}F]`,
       selectedPins: [],
       description: "",
@@ -34,14 +37,15 @@
 
     this.on("mouseover", () => {
-      this.fill("yellow");
+      this.fill("#FFD700");
     });
     this.on("mouseout", () => {
-      this.fill("red");
+      this.fill("#f60000");
     });
+
 
     this.initText();
   }
   _sceneFunc(context, shape) {
-    const { radiusX, radiusY, tailHeight } = this.attrs;
+    const { radiusX, radiusY, tailHeight } = this.attrs; // attrs od konva
 
     context.beginPath();
@@ -59,8 +63,10 @@
   }
 
+
   loadInfo(attrs) {
     this.info.name = attrs.obj_name;
     this.info.selectedPins = attrs.connected_pins;
     this.info.description = attrs.description;
+    this.floorNum = attrs.floor_num
   }
 
@@ -69,5 +75,11 @@
     this.setAttr("connected_pins", this.info.selectedPins);
     this.setAttr("description", this.info.description);
+    this.setAttr("floor_num",this.floorNum)
     console.log(this.info, "vnatre vo info");
+  }
+
+  connect(node, draw = true) {
+    if(this.floorNum !== node.floorNum) return;
+    super.connect(node)
   }
 }
Index: imaps-frontend/src/scripts/shapes/Room.js
===================================================================
--- imaps-frontend/src/scripts/shapes/Room.js	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-frontend/src/scripts/shapes/Room.js	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -1,27 +1,36 @@
 import Konva from "konva";
-import MapShape from "./MapShape";
+import MapShape from "../base/MapShape.js";
 import { _registerNode } from "konva/lib/Global";
 export default class Room extends MapShape {
-  constructor(mousePos, blockSize, layer, rotation, snap, id, scaleX = 1, scaleY = 1){
+  constructor(attrs,id){
+
+      if(!attrs.fromLoad){
+          attrs.width *= 12;
+          attrs.height *= 8;
+      }
+
+      console.log(attrs.position,"hehe")
     super(
       {
-        x: mousePos.x,
-        y: mousePos.y,
-        width: blockSize * 8 * scaleX,
-        height: blockSize * 4 * scaleY,
-        fill: "#DDE0F8",
+        x: attrs.position.x,
+        y: attrs.position.y,
+        width: attrs.width * attrs.scaleX,
+        height: attrs.height * attrs.scaleY,
+        fill: "rgb(86,168,253)",
         stroke: "grey",
         strokeWidth: 1,
         name: "mapObj",
-        rotation: rotation,
+        rotation: attrs.rotation,
         draggable: true,
       },
-      layer,
-      blockSize,
-      snap
+        attrs.layer,
+        attrs.blockSize,
+        attrs.snap
     );
 
+      this.floorNum = attrs.floorNum;
+
     this._info = {
-      name: `Room ${id}`,
+      name: `Room${id} [${this.floorNum}F]`,
       type: "",
       description: "",
@@ -29,5 +38,5 @@
 
     this.type = "Room";
-    this.modalEventName = "openRoomModalEvent";
+    this.eventName = "openRoomModalEvent";
     this.id = id;
 
@@ -39,4 +48,5 @@
     this.info.type = attrs.room_type;
     this.info.description = attrs.description;
+    this.floorNum = attrs.floor_num;
   }
 
@@ -45,4 +55,5 @@
     this.setAttr("room_type", this.info.type);
     this.setAttr("description", this.info.description);
+    this.setAttr("floor_num",this.floorNum);
   }
 }
